/********************************** (C) COPYRIGHT *******************************
* File Name          : ADC.C
* Author             : WCH
* Version            : V1.4
* Date               : 2021/12/15
* Description        : CH549 ADCʱãADCͨú¶ȼʼ
*******************************************************************************/
#include "ADC.H"
#pragma  NOAREGS
/*******************************************************************************
* Function Name  : ADC_ExInit
* Description    : ADC ⲿͨʼ
* Input          : UINT8 AdcClk
                   0 :512 Fosc cycles for each ADC
                   1 :256 Fosc cycles for each ADC
                   2 :128 Fosc cycles for each ADC
                   3 :64  Fosc cycles for each ADC
* Output         : None
* Return         : None
*******************************************************************************/
void ADC_ExInit( UINT8 AdcClk )
{
    UINT8 dat;
    ADC_CFG |= bADC_EN;                              //ADCģԴ
    ADC_CFG = (ADC_CFG & ~(bADC_CLK0 | bADC_CLK1))|AdcClk;//ѡADCοʱ
    ADC_CFG |= bADC_AIN_EN;                          //ⲿͨ
    dat = ADC_DAT;                                   //ն
    ADC_CTRL = bADC_IF;                              //ADCתɱ־д1
#if EN_ADC_INT
     SCON2 &= ~bU2IE;                                  //UART2жϵַãж2ѡ1
    IE_ADC = 1;                                      //ADCжʹ
    EA = 1;                                          //жʹ
#endif
}
/*******************************************************************************
* Function Name  : ADC_ChSelect
* Description    : ADC ⲿͨѡ
* Input          : UINT8 ch
                   ch, λ 0~15bitֱӦⲿ16ͨ
* Output         : None
* Return         : None
*******************************************************************************/
void ADC_ChSelect( UINT8 ch )
{
    ADC_CHAN = (ADC_CHAN & ~MASK_ADC_CHAN) | ch;
    if(ch<=7)                                  //P10~P17,ÿζ
    {
        P1_MOD_OC &= ~( 1 << ch );                       //
        P1_DIR_PU &= ~( 1 << ch );
    }
    if(ch>7 && ch<=0x0f)                                  //P00~P07ãÿζ
    {
        P0_MOD_OC &= ~( 1 << (ch-8) );                  //
        P0_DIR_PU &= ~( 1 << (ch-8) );
    }
}
/*******************************************************************************
* Function Name  : ADC_InTSInit
* Description    : ADC ڲͨ¶ͨʼ
                   ڲ¶ȼ⣬رⲿͨ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void ADC_InTSInit(void)
{
    ADC_CFG |= bADC_EN;                              //ADCģԴ
    ADC_CFG = ADC_CFG & ~(bADC_CLK0 | bADC_CLK1);    //ѡADCοʱ 750KHz
    ADC_CFG &= ~bADC_AIN_EN;                         //رⲿͨ
    ADC_CHAN = ADC_CHAN &~MASK_ADC_I_CH | (3<<4);    //ڲͨ3Ϊ¶ȼͨ
    ADC_CTRL |= bADC_IF;                             //ADCתɱ־д1
#if EN_ADC_INT
     SCON2 &= ~bU2IE;                                  //UART2жϵַãж2ѡ1
    IE_ADC = 1;                                      //ADCжʹ
    EA = 1;                                          //жʹ
#endif
}
#if EN_ADC_INT
/*******************************************************************************
* Function Name  : ADC_ISR( )
* Description    : ADC жϷ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void ADC_ISR(void)  interrupt INT_NO_ADC
{
    if(ADC_CTRL&bADC_IF)
    {
        ADC_CTRL = bADC_IF;                          //ADCתжϱ־
        GetValueFlag = 1;			
    }	
    ADC_ChSelect(CH0);                               //ѡһҪɼͨ	
}
#endif
