/********************************** (C) COPYRIGHT *******************************
* File Name          : DEBUG.C
* Author             : WCH
* Version            : V1.4
* Date               : 2021/12/15
* Description        : CH5XX DEBUG Interface
                     (1)Ƶ;
                     (2)us\msʱ;										 
                     (3)0ӡϢʿɵ;            				   
                     (4)Źʼ͸ֵ;    										 
*******************************************************************************/

#include ".\Public\CH549.H"
#include ".\Public\DEBUG.H"

/*******************************************************************************
* Function Name  : CfgFsys( )
* Description    : CH5XXʱѡú,Ĭʹڲ24MHzFREQ_SYS
                   PLL_CFGCLOCK_CFGõõʽ£
                   Fsys = (Fosc * ( PLL_CFG & MASK_PLL_MULT ))/(CLOCK_CFG & MASK_SYS_CK_DIV);
                   ʱҪԼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void CfgFsys( )  
{
#if OSC_EN_XT	
		SAFE_MOD = 0x55;
		SAFE_MOD = 0xAA;
    CLOCK_CFG |= bOSC_EN_XT;                          //ʹⲿ
		mDelaymS(10);
		SAFE_MOD = 0x55;
		SAFE_MOD = 0xAA;
    CLOCK_CFG &= ~bOSC_EN_INT;                        //رڲ
		SAFE_MOD = 0x00;
#else
		SAFE_MOD = 0x55;
		SAFE_MOD = 0xAA;
    CLOCK_CFG |= bOSC_EN_INT;                        //ʹڲ 
    CLOCK_CFG &= ~bOSC_EN_XT;                        //رⲿ	
#endif	
		SAFE_MOD = 0x55;
		SAFE_MOD = 0xAA;
#if FREQ_SYS == 48000000	
		CLOCK_CFG = CLOCK_CFG & ~ MASK_SYS_CK_SEL | 0x07;  // 48MHz	
#endif	
#if FREQ_SYS == 32000000	
		CLOCK_CFG = CLOCK_CFG & ~ MASK_SYS_CK_SEL | 0x06;  // 32MHz	
#endif	
#if FREQ_SYS == 24000000		
		CLOCK_CFG = CLOCK_CFG & ~ MASK_SYS_CK_SEL | 0x05;  // 24MHz	
#endif
#if FREQ_SYS == 16000000		
		CLOCK_CFG = CLOCK_CFG & ~ MASK_SYS_CK_SEL | 0x04;  // 16MHz
#endif	
#if FREQ_SYS == 12000000		
		CLOCK_CFG = CLOCK_CFG & ~ MASK_SYS_CK_SEL | 0x03;  // 12MHz	
#endif	
#if FREQ_SYS == 3000000	
		CLOCK_CFG = CLOCK_CFG & ~ MASK_SYS_CK_SEL | 0x02;  // 3MHz	
#endif
#if FREQ_SYS == 750000	
		CLOCK_CFG = CLOCK_CFG & ~ MASK_SYS_CK_SEL | 0x01;  // 750KHz
#endif
#if FREQ_SYS == 187500	
		CLOCK_CFG = CLOCK_CFG & ~ MASK_SYS_CK_SEL | 0x00;  // 187.5KHz	
#endif
		SAFE_MOD = 0x00;
}

/*******************************************************************************
* Function Name  : mDelayus(UNIT16 n)
* Description    : usʱ
* Input          : UNIT16 n
* Output         : None
* Return         : None
*******************************************************************************/ 
void mDelayuS( UINT16 n )  // uSΪλʱ
{
	while ( n ) {  // total = 12~13 Fsys cycles, 1uS @Fsys=12MHz
		++ SAFE_MOD;  // 2 Fsys cycles, for higher Fsys, add operation here
#ifdef	FREQ_SYS
#if		FREQ_SYS >= 14000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 16000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 18000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 20000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 22000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 24000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 26000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 28000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 30000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 32000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 34000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 36000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 38000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 40000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 42000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 44000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 46000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 48000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 50000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 52000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 54000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 56000000
		++ SAFE_MOD;
#endif
#endif
		-- n;
	}
}

/*******************************************************************************
* Function Name  : mDelayms(UNIT16 n)
* Description    : msʱ
* Input          : UNIT16 n
* Output         : None
* Return         : None
*******************************************************************************/
void mDelaymS( UINT16 n )                                                  // mSΪλʱ
{
	while ( n ) 
	{
		mDelayuS( 1000 );
		-- n;
	}
}                                         

/*******************************************************************************
* Function Name  : CH549UART0Alter()
* Description    : CH5490ӳ,ӳ䵽P0.2(R)P0.3(T)
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH549UART0Alter()
{
	P0_MOD_OC |= (3<<2);                                                   //׼˫ģʽ
	P0_DIR_PU |= (3<<2);
	PIN_FUNC |= bUART0_PIN_X;                                              //Ÿù
}

/*******************************************************************************
* Function Name  : mInitSTDIO()
* Description    : CH5590ʼ,ĬʹT1UART0Ĳʷ,ҲʹT2
                   Ϊʷ
* Input          : None
* Output         : None+
* Return         : None
*******************************************************************************/
void mInitSTDIO( )
{
    UINT32 x;
    UINT8 x2; 

    SM0 = 0;
    SM1 = 1;
    SM2 = 0;                                                                   //0ʹģʽ1
                                                                               //ʹTimer1Ϊʷ
    RCLK = 0;                                                                  //UART0ʱ
    TCLK = 0;                                                                  //UART0ʱ
    PCON |= SMOD;
    x = 10 * FREQ_SYS / UART0BUAD / 16;                                        //ƵעxֵҪ                            
    x2 = x % 10;
    x /= 10;
    if ( x2 >= 5 ) x ++;                                                       //

    TMOD = TMOD & ~ bT1_GATE & ~ bT1_CT & ~ MASK_T1_MOD | bT1_M1;              //0X20Timer1Ϊ8λԶضʱ
    T2MOD = T2MOD | bTMR_CLK | bT1_CLK;                                        //Timer1ʱѡ
    TH1 = 0-x;                                                                 //12MHz,buad/12Ϊʵò
    TR1 = 1;                                                                   //ʱ1
    TI = 1;
    REN = 1;                                                                   //0ʹ
}

 /*******************************************************************************
 * Function Name  : CH549SoftReset()
 * Description    : CH549λ
 * Input          : None
 * Output         : None
 * Return         : None
 *******************************************************************************/
void CH549SoftReset( )
{
	SAFE_MOD = 0x55;
	SAFE_MOD = 0xAA;
	GLOBAL_CFG |= bSW_RESET;
}
/*******************************************************************************
* Function Name  : CH549WDTModeSelect(UINT8 mode)
* Description    : CH549Źģʽѡ
*                  8λڣ룩 (131072/FREQ_SYS)*256-WDOG_COUNT
* Input          : UINT8 mode 
                   0  timer
                   1  watchDog
* Output         : None
* Return         : None
*******************************************************************************/
void CH549WDTModeSelect(UINT8 mode)
{
   SAFE_MOD = 0x55;
   SAFE_MOD = 0xaa;                                                             //밲ȫģʽ
   if(mode){
     GLOBAL_CFG |= bWDOG_EN;                                                    //Źλ
   }
   else GLOBAL_CFG &= ~bWDOG_EN;	                                              //ŹΪʱ
   SAFE_MOD = 0x00;                                                             //˳ȫģʽ
   WDOG_COUNT = 0;                                                              //Źֵ
}

/*******************************************************************************
* Function Name  : CH549WDTFeed(UINT8 tim)
* Description    : CH549Źʱʱ
* Input          : UINT8 tim Źλʱ
                   00H(12MHz)=2.8s     00H(24MHz)=1.4s
                   80H(12MHz)=1.4s     80H(24MHz)=0.7s
* Output         : None
* Return         : None
*******************************************************************************/
void CH549WDTFeed(UINT8 tim)
{
   WDOG_COUNT = tim;                                                             //Źֵ	
}



